#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const int mod=1e9+7;
struct zapros {
    int n;
    int l;
    int r;
    int x;
};
vector<int> tree;
vector<int> p;
void push(int v, int l, int r) {
    int x=p[v];
    p[v]=2;
    if(l+1==r) {
        return;
    }
    if(x!=2) {
        int m=(l+r)/2;
        tree[2*v+1]=(m-l)*x;
        p[2*v+1]=x;
        tree[2*v+2]=(r-m)*x;
        p[2*v+2]=x;
    }
}
void update(int v, int l, int r, int ql, int qr, int x) {
    push(v,l,r);
    if(l>=qr || r<=ql) {
        return;
    }
    if(ql<=l && r<=qr) {
        tree[v]=(r-l)*x;
        p[v]=x;
        return;
    }
    int m=(l+r)/2;
    update(2*v+1,l,m,ql,qr,x);
    update(2*v+2,m,r, ql, qr, x);
    tree[v]=tree[2*v+1]+tree[2*v+2];
}
int get(int v, int l, int r, int ql, int qr) {
    push(v,l,r);
    if(ql>=r || qr<=l) {
        return 0;
    }
    if(ql<=l && r<=qr) {
        return tree[v];
    }
    int m=(l+r)/2;
    return get(2*v+1,l,m,ql,qr)+get(2*v+2,m,r,ql,qr);
}
vector<vector<int> > a;
vector<int> pos;
vector<int> t;
void dfs(int v) {
    if(pos[v]==-1) {
        t.push_back(v);
    }
    for(int i=0;i<a[v].size();i++) {
        int u=a[v][i];
        if(u==0) {
                if(i==0 && pos[v]==0) {
                    t.push_back(v);
                }
            continue;
        }
        dfs(u);
        if(i==0 && pos[v]==0) {
            t.push_back(v);
            continue;
        }
    }
    if(pos[v]==1) {
        t.push_back(v);
    }
}
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    a=vector<vector<int> >(n+1);
    pos=vector<int>(n+1,-1);
    t=vector<int>(0);
    tree=vector<int>(4*(n+1),-1);
    p=vector<int>(4*(n+1),2);
    vector<int> g(n+1);
    for(int i=1;i<=n;i++) {
        int l, r;
        cin >> l >> r;
        a[i].push_back(l);
        a[i].push_back(r);
    }
    vector<zapros> z(q+1,{0,0,0,0});
    for(int i=1;i<=q;i++) {
        int f;
        cin >> f;
        if(f==1) {
            int l, r;
            cin >> l >> r;
            z[i].l=l;
            z[i].r=r;
            z[i].n=1;
            int x;
            cin >> x;
            z[i].x=x;
        }
        if(f==2) {
            int l;
            cin >> l;
            z[i].l=l;
            z[i].n=2;
        }
    }
    for(int i=1;i<=q;i++) {
        if(z[i].n==1) {
            update(0,0,n+1,z[i].l,z[i].r+1,z[i].x);
            if(i!=q && z[i+1].n==2) {
                for(int j=1;j<=n;j++) {
                    pos[j]=get(0,0,n+1,j,j+1);
                }
                dfs(1);
                for(int i=0;i<t.size();i++) {
                    g[t[i]]=i+1;
                }
            }
        }
        if(z[i].n==2) {
            cout << g[z[i].l] << " ";
        }
    }
}
