#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const int mod=1e9+7;
struct zapros {
    int n;
    int l;
    int r;
    int x;
};
vector<int> tree;
vector<int> p;
void push(int v, int l, int r) {
    int x=p[v];
    p[v]=2;
    if(l+1==r) {
        return;
    }
    if(x!=2) {
        int m=(l+r)/2;
        tree[2*v+1]=(m-l)*x;
        p[2*v+1]=x;
        tree[2*v+2]=(r-m)*x;
        p[2*v+2]=x;
    }
}
void update(int v, int l, int r, int ql, int qr, int x) {
    push(v,l,r);
    if(l>=qr || r<=ql) {
        return;
    }
    if(ql<=l && r<=qr) {
        tree[v]=(r-l)*x;
        p[v]=x;
        return;
    }
    int m=(l+r)/2;
    update(2*v+1,l,m,ql,qr,x);
    update(2*v+2,m,r, ql, qr, x);
    tree[v]=tree[2*v+1]+tree[2*v+2];
}
int get(int v, int l, int r, int ql, int qr) {
    push(v,l,r);
    if(ql>=r || qr<=l) {
        return 0;
    }
    if(ql<=l && r<=qr) {
        return tree[v];
    }
    int m=(l+r)/2;
    return get(2*v+1,l,m,ql,qr)+get(2*v+2,m,r,ql,qr);
}
vector<int> tree2;
vector<int> p2;
void push2(int v, int l, int r) {
    int x=p2[v];
    p2[v]=0;
    if(l+1==r) {
        return;
    }
    if(x!=2) {
        int m=(l+r)/2;
        tree2[2*v+1]+=(m-l)*x;
        p2[2*v+1]+=x;
        tree2[2*v+2]+=(r-m)*x;
        p2[2*v+2]+=x;
    }
}
void update2(int v, int l, int r, int ql, int qr, int x) {
    push2(v,l,r);
    if(l>=qr || r<=ql) {
        return;
    }
    if(ql<=l && r<=qr) {
        tree2[v]+=(r-l)*x;
        p2[v]+=x;
        return;
    }
    int m=(l+r)/2;
    update2(2*v+1,l,m,ql,qr,x);
    update2(2*v+2,m,r, ql, qr, x);
    tree2[v]=tree2[2*v+1]+tree2[2*v+2];
}
int get2(int v, int l, int r, int ql, int qr) {
    push2(v,l,r);
    if(ql>=r || qr<=l) {
        return 0;
    }
    if(ql<=l && r<=qr) {
        return tree2[v];
    }
    int m=(l+r)/2;
    return get2(2*v+1,l,m,ql,qr)+get2(2*v+2,m,r,ql,qr);
}
vector<vector<int> > a;
vector<int> pos;
vector<int> t;
vector<pair<int,int> > lr;
void dfs(int v) {
    if(pos[v]==-1) {
        t.push_back(v);
    }
    for(int i=0;i<a[v].size();i++) {
        int u=a[v][i];
        if(u==0) {
                if(i==0 && pos[v]==0) {
                    t.push_back(v);
                }
            continue;
        }
        dfs(u);
        if(i==0) {
            lr[v].first=lr[u].first+lr[u].second+1;
        }
        if(i==1) {
            lr[v].second=lr[u].first+lr[u].second+1;
        }
        if(i==0 && pos[v]==0) {
            t.push_back(v);
            continue;
        }
    }
    if(pos[v]==1) {
        t.push_back(v);
    }
}
int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    a=vector<vector<int> >(n+1);
    lr=vector<pair<int,int> >(n+1,{0,0});
    pos=vector<int>(n+1,-1);
    t=vector<int>(0);
    tree=vector<int>(4*(n+1),-1);
    p=vector<int>(4*(n+1),2);
    vector<int> g(n+1);
    for(int i=1;i<=n;i++) {
        int l, r;
        cin >> l >> r;
        a[i].push_back(l);
        a[i].push_back(r);
    }
    vector<zapros> z(q+1,{0,0,0,0});
    bool k=true;
    int x=0;
    for(int i=1;i<=q;i++) {
        int f;
        cin >> f;
        if(f==1) {
                x++;
            int l, r;
            cin >> l >> r;
            z[i].l=l;
            z[i].r=r;
            z[i].n=1;
            int x;
            cin >> x;
            z[i].x=x;
            if(z[i].l!=z[i].r) {
                k=false;
            }
        }
        if(f==2) {
            int l;
            cin >> l;
            z[i].l=l;
            z[i].n=2;
        }
    }
    if(x<=10) {
        vector<int> d(n+1);
    dfs(1);
    for(int i=0;i<t.size();i++) {
        d[t[i]]=i+1;
    }
        for(int i=1;i<=q;i++) {
            if(z[i].n==1) {
                for(int j=z[i].l;j<=z[i].r;j++) {
                    pos[j]=z[i].x;
                }
                t=vector<int>(0);
                dfs(1);
                for(int i=0;i<t.size();i++) {
                    d[t[i]]=i+1;
                }
                continue;
            }
            cout << d[z[i].l] << " ";
        }
        return 0;
    }
    if(n*q<=1e8) {
        for(int i=1;i<=q;i++) {
            if(z[i].n==1) {
                for(int j=z[i].l;j<=z[i].r;j++) {
                    pos[j]=z[i].x;
                }
                continue;
            }
            t=vector<int>(0);
            dfs(1);
            vector<int> d(n+1);
            for(int j=0;j<t.size();j++) {
                d[t[j]]=j+1;
            }
            cout << d[z[i].l] << " ";
        }
        return 0;
    }
    if(k==true) {
        vector<int> d(n+1);
    dfs(1);
    for(int i=0;i<t.size();i++) {
        d[t[i]]=i+1;
    }
    tree2=vector<int>(4*(n+1),0);
    p=vector<int>(4*(n+1),0);
    for(int i=1;i<=q;i++) {
        if(z[i].n==1) {
                int v=z[i].l;
            if(pos[z[i].l]==z[i].x) {
                continue;
            }
        if(pos[v]==-1 && z[i].x==0) {
            update2(0,0,n+1,d[v],d[v]+lr[v].first,-1);
            pos[v]=z[i].x;
            d[v]+=lr[v].first;
        }
        if(pos[v]==-1 && z[i].x==1) {
            update2(0,0,n+1,d[v],d[v]+lr[v].first+lr[v].second,-1);
            pos[v]=z[i].x;
            d[v]+=lr[v].first+lr[v].second;
        }
        if(pos[v]==0 && z[i].x==-1) {
            update2(0,0,n+1,d[v],d[v]+lr[v].first,1);
            pos[v]=-1;
            d[v]-=lr[v].first;
        }
        if(pos[v]==0 && z[i].x==1) {
            update2(0,0,n+1,d[v]+lr[v].first,d[v]+lr[v].first+lr[v].second,-1);
            pos[v]=1;
            d[v]+=lr[v].second;
        }
        if(pos[v]==1 && z[i].x==0) {
            update2(0,0,n+1,d[v]+lr[v].first,d[v]+lr[v].first+lr[v].second,1);
            pos[v]=0;
            d[v]-=lr[v].second;
        }
        if(pos[v]==1 && z[i].x==-1) {
            update2(0,0,n+1,d[v],d[v]+lr[v].first+lr[v].second,1);
            pos[v]=z[i].x;
            update2(0,0,n+1,d[v]-1,d[v],(lr[v].first+lr[v].second));
        }
        continue;
        }
        int v=z[i].l;
        cout << d[v]+get2(0,0,n+1,d[v]-1,d[v]) << " ";
    }
        return 0;
    }
    for(int i=1;i<=q;i++) {
        if(z[i].n==1) {
            update(0,0,n+1,z[i].l,z[i].r+1,z[i].x);
            if(i!=q && z[i+1].n==2) {
                for(int j=1;j<=n;j++) {
                    pos[j]=get(0,0,n+1,j,j+1);
                }
                dfs(1);
                for(int i=0;i<t.size();i++) {
                    g[t[i]]=i+1;
                }
            }
        }
        if(z[i].n==2) {
            cout << g[z[i].l] << " ";
        }
    }
}
